[top]
components : ControlUnit MovementUnit SensorUnit

in : LIGHT_IN
in : START_IN

out : MOVER_OUT
out : MOVEL_OUT

%input connections
Link : LIGHT_IN SU_LIGHT_IN_TOP@SensorUnit
Link : START_IN CU_START_IN_TOP@ControlUnit

%output connections
Link : MU_MOVER_OUT_TOP@MovementUnit MOVER_OUT
Link : MU_MOVEL_OUT_TOP@MovementUnit MOVEL_OUT

%internal connections
Link : SU_LIGHT_OUT_CU@SensorUnit CU_LIGHT_IN_SU@ControlUnit
Link : CU_START_OUT_SU@ControlUnit SU_START_IN_CU@SensorUnit
Link : CU_MOVER_OUT_MU@ControlUnit MU_MOVER_IN_CU@MovementUnit
Link : CU_MOVEL_OUT_MU@ControlUnit MU_MOVEL_IN_CU@MovementUnit


[SensorUnit]
components : LS@LightSensor

in : SU_LIGHT_IN_TOP
in : SU_START_IN_CU

out : SU_LIGHT_OUT_CU

%input connections
Link : SU_LIGHT_IN_TOP ls_light_in@LS
Link : SU_START_IN_CU ls_start_in@LS

%output connections
Link : ls_light_out@LS SU_LIGHT_OUT_CU


[ControlUnit]
components : SCtrl@SensorController MCtrl@MovementController

in : CU_START_IN_TOP
in : CU_LIGHT_IN_SU

out : CU_START_OUT_SU
out : CU_MOVER_OUT_MU
out : CU_MOVEL_OUT_MU

%input connections
Link : CU_START_IN_TOP sctrl_start_in@SCtrl
Link : CU_LIGHT_IN_SU sctrl_light_in@SCtrl

%output connections
Link : sctrl_start_out@SCtrl CU_START_OUT_SU
Link : mctrl_moveR_out@MCtrl CU_MOVER_OUT_MU
Link : mctrl_moveL_out@MCtrl CU_MOVEL_OUT_MU

%internal connections
Link : sctrl_mctrl_out@SCtrl mctrl_sctrl_in@MCtrl
%currently unused connection
%Link : mctrl_sctrl_out@MCtrl sctrl_mctrl_in@SCtrl


[MovementUnit]
components : MotorR@MotorRight MotorL@MotorLeft

in : MU_MOVER_IN_CU
in : MU_MOVEL_IN_CU

out : MU_MOVER_OUT_TOP
out : MU_MOVEL_OUT_TOP

%input connections
Link : MU_MOVER_IN_CU motor_in@MotorR
Link : MU_MOVEL_IN_CU motor_in@MotorL

%output connections
Link : motor_out@MotorR MU_MOVER_OUT_TOP
Link : motor_out@MotorL MU_MOVEL_OUT_TOP

 
[LS]
lsTxTime : 00:00:00:050

[SCtrl]
scTxTime : 00:00:00:050
scRxPrepTime : 00:00:00:050

[MCtrl]
movePrepTime : 00:00:00:050
turnTime : 00:00:01:000

[MotorR]
movePrepTime : 00:00:00:050

[MotorL]
movePrepTime : 00:00:00:050
